package dareka.processor.impl;

import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.extensions.Rewriter;
import dareka.processor.HttpResponseHeader;

// [nl] watchy[W
public class WatchRewriter implements Rewriter {

	// Rewriter interface
	private static final Pattern WATCH_PAGE_PATTERN = Pattern.compile(
			"^http://(?:www|flapi)\\.nicovideo\\.jp/watch/([a-z]{2})?(\\d+)(\\?.*)?$");
	
	// URL̐K\
	public Pattern getRewriterSupportedURLAsPattern() {
		return WATCH_PAGE_PATTERN;
	}
	
	public String onMatch(Matcher match, HttpResponseHeader responseHeader, String content)
			throws IOException {
		String type = match.group(1);
		String id   = match.group(2);
		
//		// [nl] }C̏ꍇ͓eIDĂ (#026)
//		if (type == null) {
//			Matcher m = VIDEO_ID_PATTERN.matcher(content);
//			if (m.find()) {
//				NLShared.INSTANCE.putThread2Smid(id, m.group(1) + m.group(2));
//				type = m.group(1);
//				id   = m.group(2);
//			}
//		}
//		
//		// [nl] html^Cg擾 NicoCachingTitleRetriever ɓn (rc2.04)
//		if (type != null) {
//			String title = null;
//			NicoIdInfoCache info = NicoIdInfoCache.getInstance();
//			if (responseHeader.getStatusCode() == 200) {
//				title = NicoCachingTitleRetriever.getTitleFromResponse(content);
//				if (title != null) {
//					info.put(type, id, NicoCachingTitleRetriever.unescape(title));
//				}
//			}
//			if (title == null) {
//				info.putOnlyTypeAndId(type, id);
//				title = info.get(id).getTitle();
//			}
//			Logger.debugWithThread("title recorded: " + type + id + " => " + title);
//		}
// XXX \[X
		
		//
		// WatchVars 𐶐ăLbV
		// ȍ~ Rewriter ̓LbV WatchVars 𗘗pł
		//
		WatchVars vars = WatchVars.get(content);
		
		// XbhID̏ꍇ͓IDƂ̑ΉL^
		if (type == null && vars.getVideoId() != null) {
			NLShared.INSTANCE.putThread2Smid(id, vars.getVideoId());
		}
		
		if (Boolean.getBoolean("disableWatchRewriter")) {
			return content;
		}
		return vars.getReplacedContent();
	}
	
}
