package dareka.extensions;

import java.util.EventListener;

import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;

/**
 * nlFilter g Extension ̃C^[tF[X<br>
 * <b>܂dlm肶Ȃ̂Ŏg͌݊ȂĂȂ</b>
 * @since NicoCache_nl+110411mod
 * TODO EventListenerɍ킹`ɎdlύX
 */
public interface NLFilterListener extends EventListener {
	
	int NOT_SUPPORTED = 0;
	int NOT_EXISTS    = 1;
	int EXISTS        = 2;
	int EXISTS_LOW    = 3;
	
	/**
	 * nlFilter ̏ΏۃRec擾C^[tF[X
	 */
	interface Content {
		/**
		 * ΏۃRec URL 擾B
		 * @return RecURL
		 */
		String getURL();
		
		/**
		 * ΏۃRec̓e擾B
		 * @return Rec
		 */
		String getContent();
		
		/**
		 * ΏۃRec̃NGXgwb_擾B
		 * @return Rec
		 */
		HttpRequestHeader getRequestHeader();
		
		/**
		 * ΏۃRec̃X|Xwb_擾B
		 * @return Rec
		 */
		HttpResponseHeader getResponseHeader();
		
		/**
		 * RecɊ֘Atꂽϐ(nlVar)̒l擾B
		 * <code>getVariable(name, null)</code>ƓB
		 * @param name 擾ϐ
		 * @return ϐ̒lA݂Ȃꍇ null
		 */
		String getVariable(String name);
		
		/**
		 * RecɊ֘Atꂽϐ(nlVar)̒l擾B
		 * @param name 擾ϐ
		 * @param def ϐ݂Ȃꍇ̃ftHgl
		 * @return ϐ̒l
		 */
		String getVariable(String name, String def);
		
		/**
		 * RecɊ֘Atꂽϐ(nlVar)̒lݒ肷B
		 * @param name ݒ肷ϐ
		 * @param value ݒlAϐ폜ꍇ null w
		 * @return ȑO̐ݒlA݂Ȃ null
		 */
		String setVariable(String name, String value);
		
	}
	
	/**
	 * nlFilter(not nlFilter_sys)RecOɃVXeĂяoB
	 * nlFilter ÕRec̓eQƂAExtension
	 * Ǝ̕ϐ(nlVar)Oɐݒ肷AƂƂłB
	 * @param content ΏۃRec
	 */
	void nlFilterBegin(Content content);
	
	/**
	 * Replace  &lt;nlVar:name&gt; oxɃVXeĂяoB
	 * Cӂ nlVar ɑ΂ Extension Ǝ̒lԂƂłB
	 * {@link #nlFilterBegin(Content)} ŎOɒlݒ肷ꍇƈقȂA
	 * ۂ nlVar QƂꂽꍇɌĂяoB
	 * 
	 * @param name Ώۂ̕ϐ
	 * @param content ΏۃRec
	 * @return ϐ̒lAϐΏۊȌꍇ null
	 */
	String nlVarReplace(String name, Content content);
	
	/**
	 * idGroup w肳ĂāAX1ԖڂɃ}b`񂪃jR
	 * <b>smid</b>(^[a-z]{2}\d{1,9}$) ȊȌꍇɃVXeĂяoB
	 * 
	 * <p>jȐꍇ2Ԗڂ̈ȗ1ԖڂƓɂȂ邪A
	 * Extension̏ꍇ2Ԗڂ̈ȗƑ݂Ȃ̂ƂĈB
	 * ܂A2Ԗڂ̈ɐlȊOnƂŁA񂻂̂̂nƂłB
	 * 
	 * <p>ɖ{̑T|[gĂȂ URL LbV Extension A
	 * nlFilter găLbV̗LɉtB^Kp邱ƂłB
	 * 
	 * @param s1 idGroup1ԖڂɃ}b`
	 * @param s2 idGroup2ԖڂɃ}b`A݂Ȃ null
	 * @return ȉ̂ꂩ̒lԂ
	 * <ul>
	 * <li>{@link #NOT_SUPPORTED} p[^T|[gO or idGroup ɑΉĂȂ
	 * <li>{@link #NOT_EXISTS} LbV݂Ȃ
	 * <li>{@link #EXISTS}     LbV݂(<$>w̏ꍇ͒ʏLbVgp)
	 * <li>{@link #EXISTS_LOW} LbV݂(<$>w̏ꍇ̓GRm~[LbVgp)
	 * </ul>
	 */
	int idGroup(String s1, String s2);
	
	/**
	 * nlFilter ɂ LST ߂ēǂݍ܂ꂽA
	 * {@linkplain dareka.processor.impl.EasyRewriter.LST LSTANZXAPI}
	 * ʂ LST XVꂽɃVXeĂяoB
	 * dlAЂƂ LST XV "list/foo.txt"  "!list/foo.txt"
	 * Ƃx̌ĂяôŒӂ邱ƁB
	 * 
	 * @param list XVꂽXg̃t@C
	 */
	void updateLST(String list);
	
}
