package dareka.extensions;

import java.util.EventListener;

import dareka.processor.HttpRequestHeader;
import dareka.processor.HttpResponseHeader;
import dareka.processor.URLResource;
import dareka.processor.impl.Cache;

/**
 * VXẽCxgʒm󂯎C^[tF[X
 * @since NicoCache_nl+111130mod
 */
public interface SystemEventListener extends EventListener {
	
	// Constant Interface Antipattern ɊY邯ǁA
	// Extension 炵gȂ̂ŗ֐D
	
	/**
	 * VXeIɈxĂяoB
	 * <p>
	 * 擾ł: (null n)
	 */
	int SYSTEM_EXIT = 1;
	
	/**
	 * VXeIɌĂяoB
	 * ĂяõXbh͗DxŒɐݒ肳Ă̂ŁA
	 * VXeׂƌĂяoԊuOシ邱Ƃ̂ŒӁB
	 * ȂAxڂ̌Ăяo͋NɍŝŁA
	 * Ԃ̂鏉̃^C~OōsĂǂB
	 * 
	 * <p>
	 * 擾ł: (null n)
	 */
	int PERIODIC_CALL = 2;
	
	/**
	 * URL ɃLbVɌĂяoB
	 * LbVΏۂ URL ȊO͌ĂяoȂ̂ŒӁB
	 * <p>
	 * 擾ł:
	 * URL, Content, RequestHeader, ResponseHeader, URLResource<br>
	 * @see dareka.processor.URLResourceCache
	 */
	int URL_MEMCACHED = 3;
	
	/**
	 * ւ̃LbVvɃLbV̗LɊւ炸ĂяoB
	 * ɃLbVꍇɂō폜ƍēxLbVsB
	 * ߂l RESULT_NG ԂƂŃNGXĝpXX[łB
	 * <p>
	 * 擾ł: URL, RequestHeader, Cache
	 */
	int CACHE_REQUEST = 4;
	
	/**
	 * ̃LbVJnɌĂяoB
	 * ߂l RESULT_NG ԂƂœ̃LbV֎~łB
	 * <p>
	 * 擾ł: URL, RequestHeader, Cache
	 */
	int CACHE_STARTING = 5;
	
	/**
	 * ̃LbVɌĂяoB
	 * <p>
	 * 擾ł: URL, RequestHeader, ResponseHeader, Cache
	 */
	int CACHE_COMPLETED = 6;
	
	/**
	 * ̃LbVfɌĂяoB
	 * <p>
	 * 擾ł: URL, RequestHeader, ResponseHeader, Cache
	 */
	int CACHE_SUSPENDED = 7;
	
	/**
	 * ̃LbV폜ɌĂяoB
	 * ߂l RESULT_NG ԂƂŃLbV̍폜֎~łB
	 * ȂǍĂяo<b>LbV폜sȂ</b>B
	 * <p>
	 * 擾ł: Cache
	 */
	int CACHE_REMOVING = 8;
	
	/**
	 * ̃LbV폜ɌĂяoB
	 * <p>
	 * 擾ł: Cache
	 */
	int CACHE_REMOVED = 9;
	
	/**
	 * config.properties ēǂݍ݂ɌĂяoB
	 * <p>
	 * 擾ł: (null n)
	 */
	int CONFIG_RELOADED = 10;
	
	// CxgIDǉꍇ͕KɒǉĊIDlύXȂ
	
	/**
	 * Cxg̏擾C^[tF[X
	 */
	interface EventSource {
		String getURL();
		String getContent();
		HttpRequestHeader getRequestHeader();
		HttpResponseHeader getResponseHeader();
		URLResource getURLResoruce();
		Cache getCache();
	}
	
	int RESULT_OK = 0;
	int RESULT_NG = 1;
	
	/**
	 * CxgxɃVXeĂяoB
	 * Ăяo̓[h(Extension t@C̎)ƂȂB
	 * 
	 * @param id CxgID
	 * <ul>
	 * <li>{@link #SYSTEM_EXIT}     VXeI
	 * <li>{@link #PERIODIC_CALL}   Ăяo(60bԊu)
	 * <li>{@link #URL_MEMCACHED}   URL LbV
	 * <li>{@link #CACHE_REQUEST}   LbVv
	 * <li>{@link #CACHE_STARTING}  LbVJn(f)
	 * <li>{@link #CACHE_COMPLETED} LbV
	 * <li>{@link #CACHE_SUSPENDED} LbVf
	 * <li>{@link #CACHE_REMOVING}  LbV폜Jn(f)
	 * <li>{@link #CACHE_REMOVED}   LbV폜
	 * <li>{@link #CONFIG_RELOADED} RtBOēǍ
	 * </ul>
	 * @param source CxgIuWFNg(getXXX \bhŏ擾ł)B
	 * CxgIDɂĂ null 蓾̂ŁAeCxgID̎擾oQƂ̂ƁB
	 * @return ʏ {@link #RESULT_OK} ԂƁB̃Cxgɑ΂āA
	 * ̃CxgeȂꍇ {@link #RESULT_NG} ԂƏ𒆒fłB
	 */
	int onSystemEvent(int id, EventSource source);
	
}
